Subject: RE: [Simple] MSRP: Towards closure on HoL blocking issue

From: Adam Roach <[email-masked]>
Date: Wed, 30 Apr 2003 01:23:15 -0500

With enough people weighing in supporting this
approach (Jonathan, Ben, Dave, Dean, me, Henning,
Aki), and only one objecting (Cullen), it would
appear that we're rapidly approaching rough
consensus. Chairs?

(Sorry, Cullen. I understand your concern, but
the reuse requirement makes everything else too
difficult.)

/a

> -----Original Message-----
> From: Jonathan Rosenberg [mailto:[email-masked]]
> Sent: Tuesday, April 29, 2003 23:44
> To: Dean Willis
> Cc: 'David R. Oran'; 'Ben Campbell'; 'Robert Sparks'; 'Adam Roach';
> 'Paul Kyzivat'; 'Cullen Jennings'; 'Simple WG'
> Subject: Re: [Simple] MSRP: Towards closure on HoL blocking issue
> 
> 
> I concur with Dave and Dean here. Let us have no restriction 
> on message 
> sizes, and have relays use a different connection for each 
> session. We 
> should be sure to mention the idea Henning mentioned of holding on to 
> connections after the sessions terminate, so they can then be reused
> for subsequent sessions.
> 
> Furthermore, I don't even see the real troubles with supporting SCTP 
> now. I would not make it mandatory; I would rather say that everyone 
> MUST to TCP and MAY do SCTP. From rfc3264 we have a pretty 
> good handle 
> on how to support discovery for URIs that can run on multiple 
> transports.
> 
> -Jonathan R.
> 
> 
> Dean Willis wrote:
> >>-----Original Message-----
> >>From: [email-masked] [mailto:[email-masked]] On 
> >>Behalf Of David R. Oran
> >>Sent: Tuesday, April 29, 2003 10:14 AM
> >>To: Ben Campbell; Robert Sparks; Adam Roach; Jonathan 
> >>Rosenberg; Paul Kyzivat; Cullen Jennings
> >>Cc: Simple WG
> >>Subject: Re: [Simple] MSRP: Towards closure on HoL blocking issue
> >>
> >>
> >>Sorry if I'm jumping in late. I much prefer to KISS and do 
> >>nothing, as 
> >>proposed by Henning. If we want to multilex transport 
> >>connections in the 
> >>future for relays, do it with SCTP and have one stream per 
> >>client session.
> >>
> >>Dave.
> > 
> > 
> > Ok, let's see if I have this right:
> > 
> > 1) We don't mux with TCP. Ever.
> > 2) We don't size-limit.
> > 3) If your session gets congested because you sent a huge 
> message, it's your
> > fault, deal with it, and it shouldn't be bothering anybody 
> else because it's
> > on its own stream somewhere.
> > 4) Everything works fine, but we've reduced the capacity of 
> relays by
> > something less than 50%.
> > 
> > I'm happy with that. It beats trying to explain queuing 
> theory to Adam,
> > especially since he's smarter than I am. 
> > 
> > --
> > dean
> > 
> 
> -- 
> Jonathan D. Rosenberg, Ph.D.                600 Lanidex Plaza
> Chief Scientist                             Parsippany, NJ 07054-2711
> dynamicsoft
> [email-masked]                     FAX:   (973) 952-5050
> http://www.jdrosen.net                      PHONE: (973) 952-5000
> http://www.dynamicsoft.com
> 
_______________________________________________
Simple mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/simple

---

From: Jonathan Rosenberg <[email-masked]>
Date: Wed, 30 Apr 2003 02:39:00 -0400

I just want to make sure my position is clear here. I do like reuse, and 
  would prefer to support it by allowing (but not requiring) SCTP 
between relays. Each session then goes on a separate stream. We would 
not attempt to support reuse over TCP.

-Jonathan R.

---

From: Henning Schulzrinne <[email-masked]>
Date: Wed, 30 Apr 2003 08:10:40 -0400

Just as with 'HOLB', we should be careful, I think, in how we use terms. 
  Re-use can mean, for example, 'sequential re-use', where the same 
transport association/stream/connection is used for multiple MSRP 
sessions sequentially. 'Connection re-use' might mean that the same 
flow-controlled connection (SCTP association) is used for multiple MSRP 
sessions in parallel. As I pointed out earlier, both TCP (with chunking) 
and SCTP (with or without) have the same flow control problems with 
heterogeneous next hops. SCTP, with a session on each stream, has 
exactly the same properties as TCP with modest-sized chunks. In 
particular, it does NOT solve the version of HOLB that is important for 
relays.

The important part in the specification is to recommend cut-through 
switching or at least SCTP chunk switching, i.e., relays should not wait 
until the whole message is delivered before starting delivery to the 
next hop.

Jonathan Rosenberg wrote:

>  would prefer to support it by allowing (but not requiring) SCTP between 
> relays. Each session then goes on a separate stream. We would not 
> attempt to support reuse over TCP.
> 
> -Jonathan R.
> 
> 
> 
> Adam Roach wrote:
> 
>>> I concur with Dave and Dean here. Let us have no restriction on 
>>> message sizes, and have relays use a different connection for each 
>>> session. We should be sure to mention the idea Henning mentioned of 
>>> holding on to connections after the sessions terminate, so they can 
>>> then be reused
>>> for subsequent sessions.
>>>
>>> MUST to TCP and MAY do SCTP. From rfc3264 we have a pretty good 
>>> handle on how to support discovery for URIs that can run on multiple 
>>> transports.
>>>
>>> -Jonathan R.
>>>
>>>
>>> Dean Willis wrote:
>>>
>>>>> To: Ben Campbell; Robert Sparks; Adam Roach; Jonathan Rosenberg; 
>>>>> Paul Kyzivat; Cullen Jennings
>>>>> Cc: Simple WG
>>>>> Sorry if I'm jumping in late. I much prefer to KISS and do nothing, 
>>>>> as proposed by Henning. If we want to multilex transport 
>>>>> connections in the future for relays, do it with SCTP and have one 
>>>>> stream per client session.
>>>>>
>>>>> Dave.
>>>>
>>>>
>>>>

---

From: Paul Kyzivat <[email-masked]>
Date: Wed, 30 Apr 2003 15:16:47 -0400

I was one of those advocating for the connection multiplexing form of 
connection reuse. This discussion has shed enough light on the subject 
that I am more-or-less convinced that it has terrible congestion 
problems that aren't solved even with SCTP.

So I now also agree that independent connections are needed for each 
media session.

This seems to have some significant implications for MSRP. Specifically, 
I think availability of sufficient resources to establish an end-end 
path of connections needs to be verified as part of session 
establishment. One way to do this would be to actually establish the 
connections, but perhaps that isn't absolutely required.

Replacing TCP connections with individual streams in an SCTP association 
doesn't yield the proper behavior, so SCTP seems inappropriate for 
relay:relay connections. (Unless you use a separate SCTP association per 
media session.)

	Paul

Henning Schulzrinne wrote:
>> I just want to make sure my position is clear here. I do like reuse, 
>> and  would prefer to support it by allowing (but not requiring) SCTP 
>>>>>> nothing, as proposed by Henning. If we want to multilex transport